<html xmlns="https://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta http-equiv="Content-Language" content="zh-CN" />
<link href="../style/css/manual-zip.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-zip-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" />
<meta name="description" content="mod_mime_magic － Apache 2.2 中文手册 [金步国作品集]">
<title>mod_mime_magic － Apache 2.2 中文手册 [金步国]</title>
<script> var _hmt = _hmt || []; (function() { var hm = document.createElement("script"); hm.src = "https://hm.baidu.com/hm.js?2468a2c5d539e359902070bcd91865b1"; var s = document.getElementsByTagName("script")[0]; s.parentNode.insertBefore(hm, s); })(); </script>
</head>
<body><div id="page-header">
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p><p class="apache">Apache HTTP Server 版本2.2</p><img alt="" src="../images/feather.gif" /></div>
<div class="up"><a href="./index.html"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path"><a href="https://www.apache.org/">Apache</a> &gt; <a href="https://httpd.apache.org/">HTTP Server</a> &gt; <a href="https://httpd.apache.org/docs/">文档</a> &gt; <a href="../index.html">版本2.2</a> &gt; <a href="./index.html">模块</a></div>

<div id="translation-info">　　 <a href="../translator_announcement.html#thanks">致谢</a> | 本篇译者：<a href="https://www.jinbuguo.com/">金步国</a>(<a href="https://www.jinbuguo.com/">作品集</a>) | 本页最后更新：2006年10月20日</div>
<div id="page-content"><div id="preamble"><h1>Apache模块 mod_mime_magic</h1>

<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="module">
<tr><th><a href="module-dict.html#Description">说明</a></th><td>通过读取部分文件内容自动猜测文件的MIME类型</td></tr>
<tr><th><a href="module-dict.html#Status">状态</a></th><td>扩展(E)</td></tr>
<tr><th><a href="module-dict.html#ModuleIdentifier">模块名</a></th><td>mime_magic_module</td></tr>
<tr><th><a href="module-dict.html#SourceFile">源文件</a></th><td>mod_mime_magic.c</td></tr>
</table>
<h3>概述</h3>

    <p>本模块采取Unix系统下<code>file(1)</code>命令相同的方法：检查文件开始的几个字节，来判定文件的<a class="glossarylink" href="../glossary.html#mime-type" title="see glossary">MIME类型</a>。它被作为当<code class="module"><a href="../mod/mod_mime.html">mod_mime</a></code>无法解析时，用来处理的"第二道防线"。</p>

    <p>本模块源自于Unix系统命令<code>file(1)</code>的一个自由版本，它通过对来自文件的内容使用"Magic数字"和其它一些线索来判定这个文件的具体内容是什么。本模块只有当"Magic文件"在<code class="directive"><a href="#mimemagicfile">MimeMagicFile</a></code>指令中指定时才有效。</p>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="format" id="format">"Magic文件"的格式</a></h2>

    <p>Magic文件的内容是由4-5列的纯文本组成的。文件中允许包含空行，但会被忽略。注释行使用井号(<code>#</code>)来引导。剩余的行按下面列被分解：</p>

<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="bordered">
<tr class="header"><th>列</th><th>描述</th></tr>
<tr><td>1</td><td>开始检查的起始字节，"&gt;"表示基于前面的非"&gt;"行。</td></tr>
<tr class="odd"><td>2</td><td><p>匹配的数据类型</p>
        <table class="bordered">
<tr><td><code>byte</code></td><td>单个字符</td></tr>
<tr><td><code>short</code></td><td>机器字节顺序的16位整数</td></tr>
<tr><td><code>long</code></td><td>机器字节顺序的32位整数</td></tr>
<tr><td><code>string</code></td><td>任意长度的字符串</td></tr>
<tr><td><code>date</code></td><td>长整型的日期(从UNIX纪元/1970以来的秒数)</td></tr>
<tr><td><code>beshort</code></td><td>big-endian 16位整数</td></tr>
<tr><td><code>belong</code></td><td>big-endian 32位整数</td></tr>
<tr><td><code>bedate</code></td><td>big-endian 32位整型日期</td></tr>
<tr><td><code>leshort</code></td><td>little-endian 16位整数</td></tr>
<tr><td><code>lelong</code></td><td>little-endian 32位整数</td></tr>
<tr><td><code>ledate</code></td><td>little-endian 32位整型日期</td></tr>
</table></td></tr>
<tr><td>3</td><td>匹配的数据内容</td></tr>
<tr class="odd"><td>4</td><td>如果匹配文件的MIME类型</td></tr>
<tr><td>5</td><td>如果匹配文件的MIME编码方式(可选)</td></tr>
</table>

    <p>例如，下面的Magic文件行可以认出一些音频格式：</p>

    <div class="example"><pre># Sun/NeXT audio data
0      string      .snd
&gt;12    belong      1       audio/basic
&gt;12    belong      2       audio/basic
&gt;12    belong      3       audio/basic
&gt;12    belong      4       audio/basic
&gt;12    belong      5       audio/basic
&gt;12    belong      6       audio/basic
&gt;12    belong      7       audio/basic
&gt;12    belong     23       audio/x-adpcm</pre></div>

    <p>还有下面的示例可以区分带<code>*.doc</code>扩展名的文件到底是Microsoft Word文档还是Frame Maker文档(两种有相同后缀名但不兼容文件格式)。</p>

    <div class="example"><pre># Frame
0  string  \&lt;MakerFile        application/x-frame
0  string  \&lt;MIFFile          application/x-frame
0  string  \&lt;MakerDictionary  application/x-frame
0  string  \&lt;MakerScreenFon   application/x-frame
0  string  \&lt;MML              application/x-frame
0  string  \&lt;Book             application/x-frame
0  string  \&lt;Maker            application/x-frame

# MS-Word
0  string  \376\067\0\043            application/msword
0  string  \320\317\021\340\241\261  application/msword
0  string  \333\245-\0\0\0           application/msword</pre></div>

    <p>一个可选的MIME编码方式可以包含在第五列上。例如下面的行可以认出gzip压缩文件并设定他们的编码方式。</p>

    <div class="example"><pre># gzip (GNU zip, not to be confused with
#       [Info-ZIP/PKWARE] zip archiver)

0  string  \037\213  application/octet-stream  x-gzip</pre></div>
</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="performance" id="performance">性能问题</a></h2>
    <p>并不是每个系统都适用本模块的。如果你的系统吞吐量已经接近极限，或者你在进行web服务器的基准测试，你可能不希望启动这个模块，因为它的处理会显著影响服务器的性能。</p>

    <p>然而，已经有人在努力改进最初的<code>file(1)</code>代码，使它能更适合在一个非常繁忙的web服务器上工作。这主要是用在那种有数千用户自己发布文档的web服务器上。这在互联网上可能是非常常见的情况。很多情况下，如果服务器能就文件的内容作出比用文件名来区别的方式更加智能化的判断是非常有用的。甚至在当用户没有合理地命名他们的文件的情况下，它也可以用来减少那些诸如："为什么我的页面不工作啊"之类的报怨。你必须自己决定这额外的开销是否适用于你的环境。</p>
</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="notes" id="notes">注意</a></h2>
    <p>下面关于<code class="module"><a href="../mod/mod_mime_magic.html">mod_mime_magic</a></code>的记录包含在这里，是按照最初捐助者的版权限制和为了得到他们的承认。</p>

    <div class="note">
      <p>mod_mime_magic: 通过文件的Magic Number查找文件的MIME类型<br />
      Copyright (c) 1996-1997 Cisco Systems, Inc.</p>

      <p>本软件由Cisco系统有限公司于1997年7月提交给Apache组织。本软件源代码的进一步修订及新版本的派生必须承认Cisco系统有限公司是本模块的原始捐助者。所有其它许可与使用条件都属于Apache组织。</p>

      <p>本模块的部分源代码派生于最初发布在comp.sources.unix上的file命令的自由版本。根据要求，下面包含了那个程序的版权信息。</p>
    </div>

    <div class="note">
      <p> - Copyright (c) Ian F. Darwin, 1987. Written by Ian F. Darwin.</p>

      <p>本软件不隶属于美国电话电报公司(AT&amp;T)或者加利福尼亚大学董事会的任何许可。</p>

      <p>在遵循以下限制的基础上，任何人被授权免费地在任何计算机系统上为任何目的使用、修改与重新分发这个软件：</p>

      <ol>
        <li>不管后果有多严重，甚至是直接由于程序的缺陷造成的，程序的作者对于由于使用这个软件而造成的任何直接或间接的后果不承担任何责任。</li>

        <li>在清晰或冗长的声明中，软件的来源必须无误地叙述。由于少量用户可能会阅读源代码，源代码中也必须包含这一声明。</li>

        <li>改动版本必须明白标明，必须与原软件严格区分开来。由于少量用户可能会阅读源代码，源代码中也必须包含这一声明。</li>

        <li>本声明不能被删除或更改。</li>
      </ol>
    </div>

    <div class="note">
      <p>为了符合MrDarwin的条款：这是从自由的&quot;file&quot;命令而来并经过了明显的修改的版本。</p>

      <ul>
        <li>当从Apache的一个版本转移到下一个时，为了编辑方便，所有代码在一个文件中。</li>

        <li>内存分配通过Apache应用程序接口的缓冲池结构完成。</li>

        <li>在需要调用其它Apache应用程序接口例程的地方，所有的函数被提供必需的Apache应用程序接口及服务结构。(例如：通常在它自身或被调用的程序里包含了日志记录，文件操作或内存分配)</li>

        <li>Magic结构从数组被转换成了单终点链表，因为它每次只增长一条记录，它只按顺序方式处理，同时Apache API没有realloc()的替代处理方法。</li>

        <li>函数被改变成从参数获取服务器配置，而不是全局变量。(现在它应该是可重入的，但没有在线程化的环境中测试过)</li>

        <li>原来用来打印结果到stdout的地方，被改成将结果保存到一个列表，这个列表被用来在Apache请求记录中设置MIME类型。</li>

        <li>因为在这里再也不会用到命令行标志，它们被删除了。</li>
      </ul>
    </div>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="MimeMagicFile" id="MimeMagicFile">MimeMagicFile</a> <a name="mimemagicfile" id="mimemagicfile">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>使用特定的Magic文件激活根据文件内容确定文件MIME类型的功能</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>MimeMagicFile <var>file-path</var></code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config, virtual host</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>扩展(E)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_mime_magic</td></tr>
</table>
    <p><code class="directive">MimeMagicFile</code>指令用来激活本模块，默认的Magic文件保存在<code>conf/magic</code>中。相对路径是相对于<code class="directive"><a href="../mod/core.html#serverroot">ServerRoot</a></code>的。虚拟主机会使用与主服务器相同的配置文件，除非使用了更特别的设定。在后者情况下，这些特别的设定会覆盖主服务的设定。</p>

    <div class="example"><h3>示例</h3><p><code>
      MimeMagicFile conf/magic
    </code></p></div>

</div>
</div>
<div id="footer">
<p class="apache">本文允许自由的转载、引用、再分发，但必须保留译者署名并注明出处；详见：<a href="../translator_announcement.html#announcement">版权声明</a>。</p>
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p></div>
</body></html>
